﻿using System;
using System.Web.UI;
using System.Web;

namespace Mindbus
{
  [ValidationProperty("IsValid")]
  public class DropDownDataEditor : System.Web.UI.UpdatePanel, umbraco.interfaces.IDataEditor
  {

    #region -- Fields --
    private umbraco.interfaces.IData _data;
    DropDownWithSource ddlWithSource = new DropDownWithSource();
    #endregion Fields

    #region -- Constructors --

    public DropDownDataEditor(umbraco.interfaces.IData Data, string Configuration)
    {
      _data = Data;
      this.ddlWithSource.Query = Configuration;
    }

    #endregion Constructors

    #region Interrface
    public bool ShowLabel
    {
      get { return true; }
    }

    public Control Editor { get { return this; } }

    public virtual bool TreatAsRichTextEditor
    {
      get { return false; }
    }
    #endregion

    public string IsValid
    {
      get
      {
        var valid = "Valid";
        if (ddlWithSource.SelectedValue == "")
        {
          valid = "";
        }
        return valid;
      }
    }


    protected override void OnInit(EventArgs e)
    {
      this.ddlWithSource.DataBind();
      if (this._data.Value != null)
      {
        //- Set the selected branch in the list if it exists
        if (this.ddlWithSource.Items.FindByValue(this._data.Value.ToString()) != null)
        {
          this.ddlWithSource.Items.FindByValue(this._data.Value.ToString()).Selected = true;
        }
      }

      base.ContentTemplateContainer.Controls.Add(ddlWithSource);
      base.OnInit(e);
    }

    public void Save()
    {
      this._data.Value = ddlWithSource.SelectedValue;
    }
  }
}
