﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Web.UI.WebControls;

namespace Mindbus
{
  public class DropDownWithSource : DropDownList
  {
    public string Query
    {
      get
      {
        if (ViewState["Query"] != null)
        {
          return ViewState["Query"].ToString();
        }
        else
        {
          return String.Empty;
        }
      }

      set { ViewState["Query"] = value; }
    }

    public override void DataBind()
    {
      this.DataSource = GetDataSource();
      this.DataTextField = "Text";
      this.DataValueField = "Value";

      base.DataBind();
    }

    public IEnumerable GetDataSource()
    {
      string key = "CodeDrowDownList_" + Query;

      object item = null;

      ////Uncomment this code to enable caching
      //if (HttpRuntime.Cache != null)
      //  item = HttpRuntime.Cache.Get(key);
      //if (item == null)
      //{
      item = GetDataFromDB();
      //if (HttpRuntime.Cache != null)
      //  HttpRuntime.Cache.Add(key, item, null,
      //                        DateTime.Now.AddSeconds(Double.Parse(System.Configuration.ConfigurationSettings.AppSettings["cacheSeconds"])),
      //                        Cache.NoSlidingExpiration,
      //                        System.Web.Caching.CacheItemPriority.Default, null);
      //}

      return (IEnumerable)item;
    }

    public IEnumerable GetDataFromDB()
    {
      List<ListItem> lItems = new List<ListItem>();
      string command = this.Query;
      using (SqlConnection conn = new SqlConnection(System.Configuration.ConfigurationSettings.AppSettings["umbracoDbDSN"]))
      {
        conn.Open();
        using (SqlCommand cmd = new SqlCommand(command, conn))
        {
          cmd.CommandType = CommandType.Text;

          using (SqlDataReader dtr = cmd.ExecuteReader(CommandBehavior.CloseConnection))
          {
            while (dtr.Read())
            {
              if (dtr.FieldCount >= 2)
              {
                lItems.Add(new ListItem() { Text = dtr[1].ToString(), Value = dtr[0].ToString() });
              }
              if (dtr.FieldCount == 1)
              {
                lItems.Add(new ListItem() { Text = dtr[0].ToString(), Value = dtr[0].ToString() });
              }
            }
          }
        }
      }
      lItems.Insert(0, new ListItem() { Text = "---please select---", Value = "" });
      return lItems;
    }

    public class ListItem
    {
      public string Text { get; set; }
      public string Value { get; set; }
    }
  }
}
